#!/bin/bash

API_KEY='put_your_apikey_here'
WORK_DIR='/tmp'
LIST_TEMP_FILE='block.ip.list'

IPSET_NAME_1='BLOCK-IP'
IPSET_NAME_2='BLOCK-IP-LOADING'

LIST_URL="http://cyberfilter.ru/api/list/?apiKey=$API_KEY&type=block.ip&output=text"

cd $WORK_DIR

wget -N -q -P $WORK_DIR "$LIST_URL" -O $LIST_TEMP_FILE
if [ $? != 0 ]; then
    echo 'ERROR: unable get ip list file.'; exit 1
fi

ipset flush $IPSET_NAME_2
if [ $? != 0 ]; then
    echo 'ERROR: unable flush ipset'; exit 1
fi

while read -r line
do

    line="${line#"${line%%[![:space:]]*}"}"   # remove leading whitespace characters
    line="${line%"${line##*[![:space:]]}"}"   # remove trailing whitespace characters

    if [[ -n $line && ! $line =~ ^# ]]; then
	ipset add $IPSET_NAME_2 $line
    fi
    
done < "$LIST_TEMP_FILE"

ipset swap $IPSET_NAME_1 $IPSET_NAME_2
if [ $? != 0 ]; then
    echo 'ERROR: unable swap ipsets'; exit 1
fi

ipset flush $IPSET_NAME_2
if [ $? != 0 ]; then
    echo 'ERROR: unable flush ipset'; exit 1
fi

echo 'Update success'
